diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/config-store/model/display-functions.cc ns-3.33/src/config-store/model/display-functions.cc
--- ns-3.32/src/config-store/model/display-functions.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/config-store/model/display-functions.cc	2021-01-09 10:19:22.000000000 -0800
@@ -16,6 +16,7 @@
  * Authors: Faker Moatamri <faker.moatamri@sophia.inria.fr>
  *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  */
+
 #include "display-functions.h"
 #include "raw-text-config.h"
 #include "ns3/config.h"
@@ -31,8 +32,12 @@
 cell_data_function_col_1 (GtkTreeViewColumn *col, GtkCellRenderer *renderer,
                           GtkTreeModel *model, GtkTreeIter *iter, gpointer user_data)
 {
-  ModelNode *node;
+  ModelNode *node = 0;
   gtk_tree_model_get (model, iter, COL_NODE, &node, -1);
+  if (!node)
+    {
+      return;
+    }
   if (node->type == ModelNode::NODE_ATTRIBUTE)
     {
       StringValue str;
@@ -54,11 +59,16 @@
 cell_data_function_col_0 (GtkTreeViewColumn *col, GtkCellRenderer *renderer, GtkTreeModel *model,
                           GtkTreeIter *iter, gpointer user_data)
 {
-  ModelNode *node;
+  ModelNode *node = 0;
   gtk_tree_model_get (model, iter, COL_NODE, &node, -1);
   g_object_set (renderer, "editable", FALSE, (char*) 0);
-  switch (node->type)
+  if (!node)
     {
+      return;
+    }
+
+  switch (node->type)
+  {
     case ModelNode::NODE_OBJECT:
       g_object_set (renderer, "text", node->object->GetInstanceTypeId ().GetName ().c_str (), (char*) 0);
       break;
@@ -78,7 +88,7 @@
     case ModelNode::NODE_ATTRIBUTE:
       g_object_set (renderer, "text", node->name.c_str (), (char*) 0);
       break;
-    }
+  }
 }
 
 /**
@@ -91,8 +101,12 @@
   GtkTreeModel *model = GTK_TREE_MODEL (user_data);
   GtkTreeIter iter;
   gtk_tree_model_get_iter_from_string (model, &iter, path_string);
-  ModelNode *node;
+  ModelNode *node = 0;
   gtk_tree_model_get (model, &iter, COL_NODE, &node, -1);
+  if (!node)
+    {
+      return;
+    }
   NS_ASSERT (node->type == ModelNode::NODE_ATTRIBUTE);
   node->object->SetAttribute (node->name, StringValue (new_text));
 }
@@ -136,16 +150,20 @@
     }
   int col = get_col_number_from_tree_view_column (column);
 
-  ModelNode *node;
+  ModelNode *node = 0;
   gtk_tree_model_get (model, &iter, COL_NODE, &node, -1);
+  if (!node)
+    {
+      return FALSE;
+    }
 
   switch (node->type)
-    {
+  {
     case ModelNode::NODE_OBJECT:
       if (col == 0)
         {
           std::string tip = "This object is of type "
-            + node->object->GetInstanceTypeId ().GetName ();
+              + node->object->GetInstanceTypeId ().GetName ();
           gtk_tooltip_set_text (tooltip, tip.c_str ());
           return TRUE;
         }
@@ -156,7 +174,7 @@
           PointerValue ptr;
           node->object->GetAttribute (node->name, ptr);
           std::string tip = "This object is of type "
-            + ptr.GetObject ()->GetInstanceTypeId ().GetName ();
+              + ptr.GetObject ()->GetInstanceTypeId ().GetName ();
           gtk_tooltip_set_text (tooltip, tip.c_str ());
           return TRUE;
         }
@@ -167,7 +185,7 @@
       if (col == 0)
         {
           std::string tip = "This object is of type "
-            + node->object->GetInstanceTypeId ().GetName ();
+              + node->object->GetInstanceTypeId ().GetName ();
           gtk_tooltip_set_text (tooltip, tip.c_str ());
           return TRUE;
         }
@@ -177,7 +195,7 @@
         uint32_t attrIndex = 0;
         TypeId tid;
         for (tid = node->object->GetInstanceTypeId (); tid.HasParent (); tid
-               = tid.GetParent ())
+        = tid.GetParent ())
           {
             for (uint32_t i = 0; i < tid.GetAttributeN (); ++i)
               {
@@ -188,7 +206,7 @@
                   }
               }
           }
-out: if (col == 0)
+        out: if (col == 0)
           {
             std::string tip = tid.GetAttribute (attrIndex).help;
             gtk_tooltip_set_text (tooltip, tip.c_str ());
@@ -208,7 +226,7 @@
         return TRUE;
       }
       break;
-    }
+  }
   return FALSE;
 }
 
@@ -228,7 +246,7 @@
   g_signal_connect (view, "query-tooltip", (GCallback) cell_tooltip_callback, 0);
 
   gtk_tree_view_set_grid_lines (GTK_TREE_VIEW (view), GTK_TREE_VIEW_GRID_LINES_BOTH);
-  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (view), TRUE);
+  // gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (view), TRUE);
 
   col = gtk_tree_view_column_new ();
   gtk_tree_view_column_set_title (col, "Object Attributes");
@@ -254,67 +272,6 @@
 }
 
 /**
- * This is the action done when the user presses on the save button.
- * It will save the config to a file.
- *
- * \param button (unused)
- * \param user_data
- */
-void
-save_clicked (GtkButton *button, gpointer user_data)
-{
-  GtkWidget *parent_window = GTK_WIDGET (user_data);
-  GtkWidget *dialog;
-
-  dialog = gtk_file_chooser_dialog_new ("Save File", GTK_WINDOW (parent_window), GTK_FILE_CHOOSER_ACTION_SAVE,
-                                        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE,
-                                        GTK_RESPONSE_ACCEPT, (char *) 0);
-  gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (dialog),
-                                                  TRUE);
-
-  gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dialog), "config.txt");
-
-  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
-    {
-      char *filename;
-
-      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
-      RawTextConfigSave config;
-      config.SetFilename (filename);
-      config.Attributes ();
-      g_free (filename);
-    }
-
-  gtk_widget_destroy (dialog);
-}
-
-/**
- * If the user presses the button load, it will load the config file into memory.
- */
-void
-load_clicked (GtkButton *button, gpointer user_data)
-{
-  GtkWidget *parent_window = GTK_WIDGET (user_data);
-  GtkWidget *dialog;
-
-  dialog = gtk_file_chooser_dialog_new ("Open File", GTK_WINDOW (parent_window), GTK_FILE_CHOOSER_ACTION_OPEN,
-                                        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN,
-                                        GTK_RESPONSE_ACCEPT, (char *) 0);
-
-  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
-    {
-      char *filename;
-
-      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
-      RawTextConfigLoad config;
-      config.SetFilename (filename);
-      config.Attributes ();
-    }
-
-  gtk_widget_destroy (dialog);
-}
-
-/**
  * Exit the window when exit button is pressed
  */
 void
@@ -342,9 +299,12 @@
 clean_model_callback (GtkTreeModel *model, GtkTreePath *path,
                       GtkTreeIter *iter, gpointer data)
 {
-  ModelNode *node;
+  ModelNode *node = 0;
   gtk_tree_model_get (GTK_TREE_MODEL (model), iter, COL_NODE, &node, -1);
-  delete node;
+  if (node)
+    {
+      delete node;
+    }
   gtk_tree_store_set (GTK_TREE_STORE (model), iter, COL_NODE, (ModelNode*) 0,
                       -1);
   return FALSE;
@@ -360,8 +320,12 @@
                                          GtkTreeModel *model, GtkTreeIter *iter,
                                          gpointer user_data)
 {
-  ModelTypeid *node;
+  ModelTypeid *node = 0;
   gtk_tree_model_get (model, iter, COL_TYPEID, &node, -1);
+  if (!node)
+    {
+      return;
+    }
   if (node->type == ModelTypeid::NODE_ATTRIBUTE)
     {
       g_object_set (renderer, "text", node->defaultValue.c_str (), (char*) 0);
@@ -380,18 +344,23 @@
 cell_data_function_col_0_config_default (GtkTreeViewColumn *col, GtkCellRenderer *renderer, GtkTreeModel *model,
                                          GtkTreeIter *iter, gpointer user_data)
 {
-  ModelTypeid *node;
+  ModelTypeid *node = 0;
   gtk_tree_model_get (model, iter, COL_NODE, &node, -1);
   g_object_set (renderer, "editable", FALSE, (char*) 0);
-  switch (node->type)
+  if (!node)
     {
+      return;
+    }
+
+  switch (node->type)
+  {
     case ModelTypeid::NODE_TYPEID:
       g_object_set (renderer, "text", node->tid.GetName ().c_str (), (char*) 0);
       break;
     case ModelTypeid::NODE_ATTRIBUTE:
       g_object_set (renderer, "text", node->name.c_str (), (char*) 0);
       break;
-    }
+  }
 }
 
 
@@ -407,8 +376,12 @@
   GtkTreeModel *model = GTK_TREE_MODEL (user_data);
   GtkTreeIter iter;
   gtk_tree_model_get_iter_from_string (model, &iter, path_string);
-  ModelTypeid *node;
+  ModelTypeid *node = 0;
   gtk_tree_model_get (model, &iter, COL_NODE, &node, -1);
+  if (!node)
+    {
+      return;
+    }
   NS_ASSERT (node->type == ModelTypeid::NODE_ATTRIBUTE);
   if (Config::SetDefaultFailSafe (node->tid.GetAttributeFullName (node->index),StringValue (new_text)))
     {
@@ -448,11 +421,15 @@
     }
   int col = get_col_number_from_tree_view_column (column);
 
-  ModelTypeid *node;
+  ModelTypeid *node = 0;
   gtk_tree_model_get (model, &iter, COL_NODE, &node, -1);
+  if (!node)
+    {
+      return FALSE;
+    }
 
   switch (node->type)
-    {
+  {
     case ModelTypeid::NODE_TYPEID:
       if (col == 0)
         {
@@ -483,7 +460,7 @@
         return TRUE;
       }
       break;
-    }
+  }
   return FALSE;
 }
 
@@ -497,29 +474,37 @@
 void
 save_clicked_default (GtkButton *button, gpointer user_data)
 {
-  GtkWidget *parent_window = GTK_WIDGET (user_data);
-  GtkWidget *dialog;
+  GtkWindow *parent_window = GTK_WINDOW (user_data);
+
+  GtkFileChooserNative *native;
+  GtkFileChooser *chooser;
+  GtkFileChooserAction action = GTK_FILE_CHOOSER_ACTION_SAVE;
+  gint res;
+
+  native = gtk_file_chooser_native_new ("Save File",
+                                        parent_window,
+                                        action,
+                                        "_Save",
+                                        "_Cancel");
+  chooser = GTK_FILE_CHOOSER (native);
 
-  dialog = gtk_file_chooser_dialog_new ("Save File", GTK_WINDOW (parent_window), GTK_FILE_CHOOSER_ACTION_SAVE,
-                                        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_SAVE,
-                                        GTK_RESPONSE_ACCEPT, (char *) 0);
-  gtk_file_chooser_set_do_overwrite_confirmation (GTK_FILE_CHOOSER (dialog),
-                                                  TRUE);
+  gtk_file_chooser_set_do_overwrite_confirmation (chooser, TRUE);
 
-  gtk_file_chooser_set_current_name (GTK_FILE_CHOOSER (dialog), "config.txt");
+  gtk_file_chooser_set_current_name (chooser, ("config-defaults.txt"));
 
-  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
+  res = gtk_native_dialog_run (GTK_NATIVE_DIALOG (native));
+  if (res == GTK_RESPONSE_ACCEPT)
     {
       char *filename;
 
-      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
+      filename = gtk_file_chooser_get_filename (chooser);
       RawTextConfigSave config;
       config.SetFilename (filename);
       config.Default ();
       g_free (filename);
     }
 
-  gtk_widget_destroy (dialog);
+  g_object_unref (native);
 }
 
 /**
@@ -531,24 +516,108 @@
 void
 load_clicked_default (GtkButton *button, gpointer user_data)
 {
-  GtkWidget *parent_window = GTK_WIDGET (user_data);
-  GtkWidget *dialog;
+  GtkWindow *parent_window = GTK_WINDOW (user_data);
+  GtkFileChooserNative *native;
+  GtkFileChooserAction action = GTK_FILE_CHOOSER_ACTION_OPEN;
+  gint res;
+
+  native = gtk_file_chooser_native_new ("Open File",
+                                        parent_window,
+                                        action,
+                                        "_Open",
+                                        "_Cancel");
+
+  res = gtk_native_dialog_run (GTK_NATIVE_DIALOG (native));
+  if (res == GTK_RESPONSE_ACCEPT)
+    {
+      char *filename;
+      GtkFileChooser *chooser = GTK_FILE_CHOOSER (native);
+      filename = gtk_file_chooser_get_filename (chooser);
+      RawTextConfigLoad config;
+      config.SetFilename (filename);
+      config.Default ();
+      g_free (filename);
+    }
 
-  dialog = gtk_file_chooser_dialog_new ("Open File", GTK_WINDOW (parent_window), GTK_FILE_CHOOSER_ACTION_OPEN,
-                                        GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN,
-                                        GTK_RESPONSE_ACCEPT, (char *) 0);
+  g_object_unref (native);
+}
 
-  if (gtk_dialog_run (GTK_DIALOG (dialog)) == GTK_RESPONSE_ACCEPT)
+/**
+ * This is the action done when the user presses on the save button.
+ * It will save the config to a file.
+ *
+ * \param button (unused)
+ * \param user_data
+ */
+void
+save_clicked_attribute (GtkButton *button, gpointer user_data)
+{
+  GtkWindow *parent_window = GTK_WINDOW (user_data);
+
+  GtkFileChooserNative *native;
+  GtkFileChooser *chooser;
+  GtkFileChooserAction action = GTK_FILE_CHOOSER_ACTION_SAVE;
+  gint res;
+
+  native = gtk_file_chooser_native_new ("Save File",
+                                        parent_window,
+                                        action,
+                                        "_Save",
+                                        "_Cancel");
+  chooser = GTK_FILE_CHOOSER (native);
+
+  gtk_file_chooser_set_do_overwrite_confirmation (chooser, TRUE);
+
+  gtk_file_chooser_set_current_name (chooser, ("config-attributes.txt"));
+
+  res = gtk_native_dialog_run (GTK_NATIVE_DIALOG (native));
+  if (res == GTK_RESPONSE_ACCEPT)
     {
       char *filename;
 
-      filename = gtk_file_chooser_get_filename (GTK_FILE_CHOOSER (dialog));
+      filename = gtk_file_chooser_get_filename (chooser);
+      RawTextConfigSave config;
+      config.SetFilename (filename);
+      config.Attributes ();
+      g_free (filename);
+    }
+
+  g_object_unref (native);
+}
+
+/**
+ * If the user presses the button load, it will load the config file into memory.
+ *
+ * \param button (unused)
+ * \param user_data
+ */
+void
+load_clicked_attribute (GtkButton *button, gpointer user_data)
+{
+  GtkWindow *parent_window = GTK_WINDOW (user_data);
+  GtkFileChooserNative *native;
+  GtkFileChooserAction action = GTK_FILE_CHOOSER_ACTION_OPEN;
+  gint res;
+
+  native = gtk_file_chooser_native_new ("Open File",
+                                        parent_window,
+                                        action,
+                                        "_Open",
+                                        "_Cancel");
+
+  res = gtk_native_dialog_run (GTK_NATIVE_DIALOG (native));
+  if (res == GTK_RESPONSE_ACCEPT)
+    {
+      char *filename;
+      GtkFileChooser *chooser = GTK_FILE_CHOOSER (native);
+      filename = gtk_file_chooser_get_filename (chooser);
       RawTextConfigLoad config;
       config.SetFilename (filename);
-      config.Default ();
+      config.Attributes ();
+      g_free (filename);
     }
 
-  gtk_widget_destroy (dialog);
+  g_object_unref (native);
 }
 
 /**
@@ -567,7 +636,7 @@
   g_signal_connect (view, "query-tooltip", (GCallback) cell_tooltip_callback_config_default, 0);
 
   gtk_tree_view_set_grid_lines (GTK_TREE_VIEW (view), GTK_TREE_VIEW_GRID_LINES_BOTH);
-  gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (view), TRUE);
+  // gtk_tree_view_set_rules_hint (GTK_TREE_VIEW (view), TRUE);
 
   col = gtk_tree_view_column_new ();
   gtk_tree_view_column_set_title (col, "Object Attributes");
@@ -599,9 +668,12 @@
 clean_model_callback_config_default (GtkTreeModel *model, GtkTreePath *path,
                                      GtkTreeIter *iter, gpointer data)
 {
-  ModelTypeid *node;
+  ModelTypeid *node = 0;
   gtk_tree_model_get (GTK_TREE_MODEL (model), iter, COL_TYPEID, &node, -1);
-  delete node;
+  if (node)
+    {
+      delete node;
+    }
   gtk_tree_store_set (GTK_TREE_STORE (model), iter, COL_TYPEID, (ModelTypeid*) 0, -1);
   return FALSE;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/config-store/model/display-functions.h ns-3.33/src/config-store/model/display-functions.h
--- ns-3.32/src/config-store/model/display-functions.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/config-store/model/display-functions.h	2021-01-09 10:19:22.000000000 -0800
@@ -64,17 +64,6 @@
 GtkWidget *
 create_view (GtkTreeStore *model);
 /**
- * This is the action done when the user presses on the save button.
- * It will save the config to a file.
- */
-void
-save_clicked (GtkButton *button, gpointer user_data);
-/**
- * If the user presses the button load, it will load the config file into memory.
- */
-void
-load_clicked (GtkButton *button, gpointer user_data);
-/**
  * Exit the window when exit button is pressed
  */
 void
@@ -106,17 +95,28 @@
 cell_data_function_col_0_config_default (GtkTreeViewColumn *col, GtkCellRenderer *renderer, GtkTreeModel *model, 
                                          GtkTreeIter *iter, gpointer user_data);
 /**
- * This is the action done when the user presses on the save button.
+ * This is the action done when the user presses on the save button for the Default attributes.
  * It will save the config to a file.
  */
 void
 save_clicked_default (GtkButton *button, gpointer user_data);
 /**
- * If the user presses the button load, it will load the config file into memory.
+ * If the user presses the button load, it will load the config file into memory for the Default attributes.
  */
 void
 load_clicked_default (GtkButton *button, gpointer user_data);
 /**
+ * This is the action done when the user presses on the save button for the Attributes.
+ * It will save the config to a file.
+ */
+void
+save_clicked_attribute (GtkButton *button, gpointer user_data);
+/**
+ * If the user presses the button load, it will load the config file into memory for the Attributes.
+ */
+void
+load_clicked_attribute (GtkButton *button, gpointer user_data);
+/**
  *  This functions is called whenever there is a change in the value of an attribute
  *  If the input value is ok, it will be updated in the default value and in the
  *  GUI, otherwise, it won't be updated in both.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/config-store/model/gtk-config-store.cc ns-3.33/src/config-store/model/gtk-config-store.cc
--- ns-3.32/src/config-store/model/gtk-config-store.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/config-store/model/gtk-config-store.cc	2021-01-09 10:19:22.000000000 -0800
@@ -55,10 +55,10 @@
   scroll = gtk_scrolled_window_new (0, 0);
   gtk_container_add (GTK_CONTAINER (scroll), view);
 
-  GtkWidget *vbox = gtk_vbox_new (FALSE, 5);
+  GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
   gtk_box_pack_start (GTK_BOX (vbox), scroll, TRUE, TRUE, 0);
-  gtk_box_pack_end (GTK_BOX (vbox), gtk_hseparator_new (), FALSE, FALSE, 0);
-  GtkWidget *hbox = gtk_hbox_new (FALSE, 5);
+  gtk_box_pack_end (GTK_BOX (vbox), gtk_separator_new (GTK_ORIENTATION_HORIZONTAL), FALSE, FALSE, 0);
+  GtkWidget *hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 5);
   gtk_box_pack_end (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
   GtkWidget *save = gtk_button_new_with_label ("Save");
   g_signal_connect (save, "clicked",  (GCallback) save_clicked_default, window);
@@ -107,16 +107,16 @@
   scroll = gtk_scrolled_window_new (0, 0);
   gtk_container_add (GTK_CONTAINER (scroll), view);
 
-  GtkWidget *vbox = gtk_vbox_new (FALSE, 5);
+  GtkWidget *vbox = gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
   gtk_box_pack_start (GTK_BOX (vbox), scroll, TRUE, TRUE, 0);
-  gtk_box_pack_end (GTK_BOX (vbox), gtk_hseparator_new (), FALSE, FALSE, 0);
-  GtkWidget *hbox = gtk_hbox_new (FALSE, 5);
+  gtk_box_pack_end (GTK_BOX (vbox), gtk_separator_new (GTK_ORIENTATION_HORIZONTAL), FALSE, FALSE, 0);
+  GtkWidget *hbox = gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 5);
   gtk_box_pack_end (GTK_BOX (vbox), hbox, FALSE, FALSE, 0);
   GtkWidget *save = gtk_button_new_with_label ("Save");
-  g_signal_connect (save, "clicked",  (GCallback) save_clicked, window);
+  g_signal_connect (save, "clicked",  (GCallback) save_clicked_attribute, window);
   gtk_box_pack_end (GTK_BOX (hbox), save, FALSE, FALSE, 0);
   GtkWidget *load = gtk_button_new_with_label ("Load");
-  g_signal_connect (load, "clicked",  (GCallback) load_clicked, window);
+  g_signal_connect (load, "clicked",  (GCallback) load_clicked_attribute, window);
   gtk_box_pack_end (GTK_BOX (hbox), load, FALSE, FALSE, 0);
   GtkWidget *exit = gtk_button_new_with_label ("Run Simulation");
   g_signal_connect (exit, "clicked",  (GCallback) exit_clicked_callback, window);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/config-store/wscript ns-3.33/src/config-store/wscript
--- ns-3.32/src/config-store/wscript	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/config-store/wscript	2021-01-09 10:19:22.000000000 -0800
@@ -21,14 +21,14 @@
                                      conf.env['ENABLE_GTK'],
                                      "--disable-gtk option given")
     else:
-        have_gtk = conf.check_cfg(package='gtk+-3.0', atleast_version='3.0',
+        have_gtk = conf.check_cfg(package='gtk+-3.0 >= 3.20',
                                   args=['--cflags', '--libs'], uselib_store='GTK',
                                   mandatory=False)
 
         conf.env['ENABLE_GTK'] = have_gtk
         conf.report_optional_feature("GtkConfigStore", "GtkConfigStore",
                                      conf.env['ENABLE_GTK'],
-                                     "library 'gtk+-3.0 >= 3.0' not found")
+                                     "library 'gtk+-3 >= 3.2' not found")
 
         # Bug 2936 -Wparentheses issue for gcc >= 8
         if conf.env['ENABLE_GTK']: 
@@ -39,7 +39,7 @@
             if conf.env['CXX_NAME'] in ['clang', 'gcc']:
                     conf.env.append_value ('CXXFLAGS', '-Wno-error=deprecated-declarations')
 
-    have_libxml2 = conf.check_cfg(package='libxml-2.0', atleast_version='2.7',
+    have_libxml2 = conf.check_cfg(package='libxml-2.0 >= 2.7',
                                   args=['--cflags', '--libs'], uselib_store='LIBXML2',
                                   mandatory=False)
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/core/bindings/modulegen_customizations.py ns-3.33/src/core/bindings/modulegen_customizations.py
--- ns-3.32/src/core/bindings/modulegen_customizations.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/core/bindings/modulegen_customizations.py	2021-01-09 10:19:22.000000000 -0800
@@ -171,7 +171,9 @@
             root_module.classes.remove(root_module['ns3::%s' % clsname])
         root_module.enums.remove(root_module['ns3::RealtimeSimulatorImpl::SynchronizationMode'])
 
-    root_module.after_init.write_code("PyEval_InitThreads();")
+    # Issue 318: PyEval_InitThreads deprecated after Python 3.6
+    if sys.hexversion < 0x03070000:
+        root_module.after_init.write_code("PyEval_InitThreads();")
 
 # these are already in the main script, so commented out here
 # Object_customizations(root_module)
